Index: imaps-frontend/src/scripts/net/HttpService.js
===================================================================
--- imaps-frontend/src/scripts/net/HttpService.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/net/HttpService.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -3,7 +3,7 @@
 
 class HttpService {
-    constructor(auth = false) {
+    constructor(URL = config.apiBaseUrl, auth = false) {
+      this.baseURL = URL;
       this.auth = auth;
-      this.responseType = 'json';
     }
 
@@ -11,14 +11,4 @@
         this.auth = true;
     }
-    setResponseType(type){
-        if(type === 'text'){
-            this.responseType = 'text';
-        } else if (type === 'json'){
-            this.responseType = 'json'
-        } else {
-            console.error('unsupported response type in http service')
-        }
-    }
-
 
     async request(method, endpoint, data = null) {
@@ -43,5 +33,5 @@
       }
   
-      const response = await fetch(`${endpoint}`, options);
+      const response = await fetch(`${this.baseURL}${endpoint}`, options);
       
       if (!response.ok) {
@@ -64,12 +54,6 @@
 
       console.log("HTTPSERVICE: RESPONSE:",response);
-
-      if(this.responseType === 'json'){
-          return response.json();
-      } else if (this.responseType === 'text'){
-          return response.text()
-      } else{
-          console.error('bad resp type')
-      }
+  
+      return response.json();
     }
   
Index: imaps-frontend/src/scripts/net/netconfig.js
===================================================================
--- imaps-frontend/src/scripts/net/netconfig.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/net/netconfig.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,66 +1,14 @@
-export const API_BASE_URL = "http://localhost:8080/api";
-export const API_PROTECTED = `${API_BASE_URL}/protected`
-export const API_PUBLIC = `${API_BASE_URL}/public`
-export const API_AUTH = `${API_BASE_URL}/auth`
-
 
 const config = {
-    my_maps: {
-        display: `${API_PROTECTED}/my-maps`,
-        save: `${API_PROTECTED}/my-maps/save`,
-        add: `${API_PROTECTED}/my-maps/create`,
-        load: `${API_PROTECTED}/my-maps/load`,
-        delete: `${API_PROTECTED}/my-maps/delete`,
-        publish: `${API_PROTECTED}/publish/add`,
-        publish_get: `${API_PROTECTED}/publish/get`,
-        edit_map_info: `${API_PROTECTED}/my-maps/edit`,
-    },
-    room_types: {
-        display: (auth) => {
-            return auth ? `${API_PROTECTED}/room-types` : `${API_PUBLIC}/room-types`
-        },
-        add: `${API_PROTECTED}/room-types/add`,
+    apiBaseUrl: "http://localhost:8080/api",
 
-    },
-    floors: {
-        add: `${API_PROTECTED}/floors/add`,
-        load: `${API_PROTECTED}/my-maps/load`,
-        delete: `${API_PROTECTED}/floors/delete`,
-    },
-    view_maps: {
-        display: `${API_PUBLIC}/maps`,
-        load: (auth) => {
-            return auth ? `${API_PROTECTED}/load-map` : `${API_PUBLIC}/load-map`
-        },
-        navigate: `${API_PUBLIC}/navigate`,
-        add_favourite: `${API_PROTECTED}/favourites/add`,
-        add_report: `${API_PROTECTED}/reports/create`,
-    },
-    favourites: {
-        display: `${API_PROTECTED}/favourites`,
-        add: `${API_PROTECTED}/favourites/add`,
-        delete: `${API_PROTECTED}/favourites/delete`,
-    },
-    auth:{
-        login: `${API_AUTH}/login`,
-        register: `${API_AUTH}/register`,
-        verify: `${API_AUTH}/verify`,
-        oauth: {
-            github: {
-                state: `${API_BASE_URL}/oauth/state`,
-                redirectUri : `${API_BASE_URL}/oauth/callback`
-            }
-        }
-
-    },
-    admin:{
-        display: `${API_BASE_URL}/admin`,
-        load_pr: `${API_BASE_URL}/admin/load-pr`,
-        approve_pr: `${API_BASE_URL}/admin/pr/approve`,
-        deny_pr: `${API_BASE_URL}/admin/pr/deny`,
-        load_reports: `${API_BASE_URL}/admin/load-reports`
+    endpoints: {
+        login: "/auth/login",
+        register: "/auth/register",
+        verify: "/auth/verify",
+        render: "/protected/render",
+        publicMapData: "/public/mapData"
     }
 };
 
-
 export default config;
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedEntrance.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedEntrance.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedEntrance.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,44 +1,37 @@
-import RenderedMapShape from "../base/RenderedMapShape.js";
-import {_registerNode} from "konva/lib/Global";
-import RenderedRoom from "./RenderedRoom.js";
+import RenderedMapShape from "./RenderedMapShape.js";
 
-export default class RenderedEntrance extends RenderedMapShape {
-  constructor(attrs, scaleX, scaleY) {
-    super({
-      x: attrs.x,
-      y: attrs.y,
-      width: attrs.width,
-      height: attrs.height,
-      fill: "#7fef83",
-      stroke: "black",
-      strokeWidth: 1,
-      draggable: false,
-      rotation: attrs.rotation,
-      cornerRadius: 3,
-      zIndex: 0,
-    });
+export default class RenderedEntrance extends RenderedMapShape{
+    constructor(attrs,scaleX,scaleY){
+        super({
+            x: attrs.x,
+            y: attrs.y,
+            width: attrs.width * scaleX,
+            height: attrs.height * scaleY,
+            fill: '#1c3cff',
+            stroke: 'black',
+            strokeWidth: 1,
+            draggable: false,
+            rotation: attrs.rotation,
+            cornerRadius:3,
+            zIndex: 0
+        });
 
-    this.info.name = attrs.obj_name;
-    this.info.description = attrs.description;
-    this.info.isMainEntrance = attrs.is_main_entrance;
+        this.info.name = attrs.obj_name;
+        this.info.description = attrs.description;
+        
+    
+        this.on("mouseenter",() => {
+        console.log("HOVER ROOM IN", this.x());
+        console.log(this.info.name,"NAME");
+        this.stroke('purple');
+        })
+        this.on("mouseleave", () => {
+            console.log("HOVER ROOM OUT");
+            this.opacity(1);
+            this.stroke('black')
 
-    this.floorNum = attrs.floor_num
+        })
 
-    this.class = "Entrance";
-
-    console.log("ATTRS VIEW:  " + attrs)
-
-    this.on("mouseenter", () => {
-      this.stroke("purple");
-    });
-    this.on("mouseleave", () => {
-      this.opacity(1);
-      this.stroke("black");
-    });
-
-    //this.initText();
-  }
+        this.initText()
+    }
 }
-
-RenderedEntrance.prototype.className = "RenderedEntrance";
-_registerNode(RenderedEntrance);
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedMapShape.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedMapShape.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedMapShape.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,45 @@
+import Konva from "konva";
+
+export default class RenderedMapShape extends Konva.Rect{
+    constructor(config){
+        if (new.target === RenderedMapShape) {
+            throw new Error("Cannot instantiate abstract class RenderedMapShape directly.");
+          }
+
+          super(config);
+
+          this.info = {
+            name: "",
+            description: "",
+          }
+          this.infoText = null;
+          this.textOffsetX = 0;
+          this.textOffsetY = 0;
+    }
+
+    initText() {
+      this.infoText = new Konva.Text({
+        x: this.x() + this.textOffsetX,
+        y: this.y() + this.textOffsetY,
+        text: this.info.name || "no name",
+        fontSize: 12,
+        fontFamily: 'Verdana',
+        fill: 'black',
+      });
+    }
+  
+    updateTextPosition() {
+      if(this.infoText){
+        this.infoText.x(this.x() + this.textOffsetX);
+        this.infoText.y(this.y() + this.textOffsetY);
+      }
+    }
+  
+    displayName(layer) {
+        if(this.infoText != null){
+            layer.add(this.infoText);
+        }
+
+    }
+    
+}
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedRoom.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedRoom.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedRoom.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,62 +1,41 @@
-import RenderedMapShape from "../base/RenderedMapShape.js";
-import {_registerNode} from "konva/lib/Global";
+import RenderedMapShape from "./RenderedMapShape.js";
 
-export default class RenderedRoom extends RenderedMapShape {
-  constructor(attrs, scaleX, scaleY) {
-    super({
-      x: attrs.x,
-      y: attrs.y,
-      width: attrs.width,
-      height: attrs.height,
-      fill: "#A2D9FF",
-      stroke: "black",
-      strokeWidth: 1,
-      draggable: false,
-      rotation: attrs.rotation,
-      cornerRadius: 3
-    });
+export default class RenderedRoom extends RenderedMapShape{
+    constructor(attrs,scaleX,scaleY){
+        super({
+            x: attrs.x,
+            y: attrs.y,
+            width: attrs.width * scaleX,
+            height: attrs.height * scaleY,
+            fill: 'white',
+            stroke: 'black',
+            strokeWidth: 1,
+            draggable: false,
+            rotation: attrs.rotation,
+            cornerRadius:3,
+            zIndex: 0
+        });
 
-    console.info("FNUM RENDER:",attrs.floor_num)
+        this.info.name = attrs.obj_name;
+        this.info.description = attrs.description;
 
-    this.floorNum = attrs.floor_num
+        this.textOffsetX = -50
+        
+    
+        this.on("mouseenter",() => {
+        console.log("HOVER ROOM IN", this.x());
+        console.log(this.info.name,"NAME");
+        this.opacity(0.7);
+        this.fill("pink");
+        })
+        this.on("mouseleave", () => {
+            console.log("HOVER ROOM OUT");
+            this.opacity(1);
+            this.fill("white");
+        })
 
-    this.info.name = attrs.obj_name;
-    this.info.type = attrs.room_type;
-    this.info.description = attrs.description;
-    this.class = "Room";
-    this.textOffsetX = -50;
+        this.initText()
+    }
 
-    this.eventName = "openRoomInfoPanel"
-
-    this.on("mouseenter", () => {
-      console.log(this.info.name, "NAME");
-      this.fill("#65c3f8");
-    });
-    this.on("mouseleave", () => {
-      this.fill("#A2D9FF");
-    });
-
-
-
-    // searched(){
-    //   this.fill("#b92d39")
-    // }
-    // unsearched(){
-    //   this.fill("#A2D9FF");
-    // }
-
-    // console.log("ATTRS: " + attrs);
-
-    this.initText();
-  }
-  highlight(){
-    this.fill("rgba(29,238,78,0.49)");
-    this.strokeWidth(2)
-  }
-  unHighlight(){
-    this.fill("#A2D9FF");
-    this.strokeWidth(1);
-  }
+   
 }
-RenderedRoom.prototype.className = "RenderedRoom";
-_registerNode(RenderedRoom);
Index: imaps-frontend/src/scripts/rendered_shapes/RenderedWall.js
===================================================================
--- imaps-frontend/src/scripts/rendered_shapes/RenderedWall.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/rendered_shapes/RenderedWall.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,4 +1,3 @@
-import RenderedMapShape from "../base/RenderedMapShape.js";
-import {_registerNode} from "konva/lib/Global";
+import RenderedMapShape from "./RenderedMapShape.js";
 
 export default class RenderedWall extends RenderedMapShape{
@@ -7,7 +6,7 @@
             x: attrs.x,
             y: attrs.y,
-            width: attrs.width,
-            height: attrs.height,
-            fill: '#4B4B4B',
+            width: attrs.width * scaleX,
+            height: attrs.height * scaleY,
+            fill: 'grey',
             stroke: 'black',
             strokeWidth: 1,
@@ -19,5 +18,2 @@
     }
 }
-
-RenderedWall.prototype.className = "RenderedWall";
-_registerNode(RenderedWall);
Index: imaps-frontend/src/scripts/shapes/Entrance.js
===================================================================
--- imaps-frontend/src/scripts/shapes/Entrance.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/shapes/Entrance.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,109 +1,58 @@
-import {_registerNode} from "konva/lib/Global";
-import MapNode from "../base/MapNode.js";
-import {node} from "prop-types";
-import ShapeRegistry from "../util/ShapeRegistry.js";
-import ShapeQuery from "../util/ShapeQuery.js";
 import Konva from "konva";
+import MapShape from "./MapShape";
+import { _registerNode } from "konva/lib/Global";
+export default class Entrance extends MapShape {
+  constructor(mousePos, blockSize, layer, rotation, snap,id,scaleX = 1, scaleY = 1) {
+    super(
+      {
+        x: mousePos.x,
+        y: mousePos.y,
+        width: blockSize * scaleX,
+        height: blockSize * 2 * scaleY,
+        fill: "#0051ff",
+        stroke: "grey",
+        strokeWidth: 1,
+        opacity: 0.7,
+        name: "mapObj",
+        draggable: true,
+        rotation: rotation,
+        zIndex: 1,
+      },
+      layer,
+      blockSize,
+      snap
+    );
+    this.type = "Entrance";
+    this.modalEventName = "openEntranceModalEvent";
 
-export default class Entrance extends MapNode {
+    this.id = id;
 
-    constructor(attrs, id) {
+    this._info = {
+      name: `Entrance ${id}`,
+      connectedRoom: "",
+      description: "",
+      isMainEntrance: false,
+      selectedPin: "",
+      selectedPins: [],
+    };
 
-        if (!attrs.fromLoad) {
-            attrs.height *= 2;
-        }
-        super(
-            {
-                x: attrs.position.x,
-                y: attrs.position.y,
-                width: attrs.width * attrs.scaleX,
-                height: attrs.height * attrs.scaleY,
-                fill: "rgb(126,238,167)",
-                stroke: "#252627",
-                strokeWidth: 1,
-                opacity: 0.9,
-                name: "mapObj",
-                draggable: true,
-                rotation: attrs.rotation,
-                zIndex: 1,
-            },
-            attrs.layer,
-            attrs.blockSize,
-            attrs.snap
-        );
-        this.type = "Entrance";
-        this.eventName = "openEntranceModalEvent";
-        this.floorNum = attrs.floorNum
+    this.initText();
+  }
 
-        this.id = id;
+  loadInfo(attrs) {
+    this.info.name = attrs.obj_name;
+    this.info.connectedRoom = attrs.connected_room;
+    this.info.description = attrs.description;
+    this.info.isMainEntrance = attrs.is_main_entrance;
+    this.info.selectedPins = attrs.connected_pins;
+  }
 
-        this._info = {
-            name: `Entrance${id} [${this.floorNum}F]`,
-            connectedRoom: "",
-            description: "",
-            isMainEntrance: false,
-            selectedPin: "",
-            selectedPins: [],
-        };
-
-        this.initText();
-        this.moveToTop();
-
-        console.log("room CONNECT: " + attrs.connected_room,this.info.connectedRoom + "CON")
-        console.log("entrance: " + this.info.name)
-    }
-
-    loadInfo(attrs) {
-        this.info.name = attrs.obj_name ?? `Entrance${this.id} [${this.floorNum}F]`;
-        this.info.connectedRoom = attrs.connected_room ?? ``;
-        this.info.description = attrs.description ?? ``;
-        this.info.isMainEntrance = attrs.is_main_entrance ?? false;
-        this.info.selectedPins = attrs.connected_pins ?? [];
-    }
-
-
-    saveShapeDetails() {
-        console.info("fnum entrance",this.attrs.floorNum)
-        this.setAttr("connected_pins", this.info.selectedPins);
-        this.setAttr("obj_name", this.info.name);
-        this.setAttr("description", this.info.description);
-        this.setAttr("is_main_entrance", this.info.isMainEntrance);
-        this.setAttr("connected_room", this.info.connectedRoom);
-        this.setAttr("floor_num",this.floorNum);
-    }
-
-    connect(node, draw = true) {
-        if(this.floorNum !== node.floorNum) return;
-
-        super.connect(node)
-    }
-
-    setInfo(infoObj) {
-        this.info = infoObj;
-        this.setHighlight();
-    }
-
-    setHighlight(){
-        console.log("info room: " + this.info.connectedRoom)
-        if(this.info.connectedRoom == null || this.info.connectedRoom === "" ){
-            console.log("vleze if")
-            this.strokeWidth(2);
-            this.stroke("#8a000d")
-        }else{
-            this.strokeWidth(1)
-            this.stroke("black")
-        }
-    }
-
-    onPlace() {
-        ShapeQuery
-            .findAllByTypeAndFloor(this.floorNum,"Room")
-            .forEach(room => {
-                if(Konva.Util.haveIntersection(room.getClientRect(),this.getClientRect())){
-                    this.info.connectedRoom = room.info.name;
-                }
-            })
-        this.setHighlight()
-    }
+  saveShapeDetails() {
+    this.setAttr("connected_pins", this.info.selectedPins);
+    this.setAttr("obj_name", this.info.name);
+    this.setAttr("description", this.info.description);
+    this.setAttr("is_main_entrance", this.info.isMainEntrance);
+    this.setAttr("connected_room", this.info.connectedRoom);
+  }
 }
 
Index: imaps-frontend/src/scripts/shapes/InfoPin.js
===================================================================
--- imaps-frontend/src/scripts/shapes/InfoPin.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/shapes/InfoPin.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,35 +1,32 @@
-
+import Konva from "konva";
+import MapShape from "./MapShape";
+import Factory from "../util/Factory";
 import { _registerNode } from "konva/lib/Global";
-import MapNode from "../base/MapNode.js";
-import {node} from "prop-types";
-import draw from "../../pages/Draw/Draw.jsx";
-export default class InfoPin extends MapNode {
-  constructor(attrs,id) {
-    attrs.snap = false;
+export default class InfoPin extends MapShape {
+  constructor(mousePos, blockSize, layer, snappable,id) {
     super(
       {
-        x: attrs.position.x,
-        y: attrs.position.y,
-        radiusX: attrs.blockSize * 0.5,
-        radiusY: attrs.blockSize * 0.7,
-        tailHeight: attrs.blockSize * 1.2,
-        fill: "#f60000",
+        x: mousePos.x,
+        y: mousePos.y,
+        radiusX: blockSize * 0.5,
+        radiusY: blockSize * 0.7,
+        tailHeight: blockSize * 1.2,
+        fill: "#d70113",
         stroke: "#1b1b1b",
-        strokeWidth: 1,
+        strokeWidth: 0.2,
         draggable: true,
         name: "mapObj",
       },
-      attrs.layer,
-      attrs.blockSize,
-      attrs.snap
+      layer,
+      blockSize,
+      snappable
     );
 
     this.id = id;
-    this.eventName = "openPinModalEvent";
-    this.floorNum = attrs.floorNum;
 
+    this.modalEventName = "openPinModalEvent";
     this.type = "InfoPin";
     this._info = {
-      name: `Pin${id} [${this.floorNum}F]`,
+      name: `Pin ${id}`,
       selectedPins: [],
       description: "",
@@ -37,15 +34,14 @@
 
     this.on("mouseover", () => {
-      this.fill("#FFD700");
+      this.fill("yellow");
     });
     this.on("mouseout", () => {
-      this.fill("#f60000");
+      this.fill("red");
     });
-
 
     this.initText();
   }
   _sceneFunc(context, shape) {
-    const { radiusX, radiusY, tailHeight } = this.attrs; // attrs od konva
+    const { radiusX, radiusY, tailHeight } = this.attrs;
 
     context.beginPath();
@@ -63,10 +59,8 @@
   }
 
-
   loadInfo(attrs) {
     this.info.name = attrs.obj_name;
     this.info.selectedPins = attrs.connected_pins;
     this.info.description = attrs.description;
-    this.floorNum = attrs.floor_num
   }
 
@@ -75,11 +69,5 @@
     this.setAttr("connected_pins", this.info.selectedPins);
     this.setAttr("description", this.info.description);
-    this.setAttr("floor_num",this.floorNum)
     console.log(this.info, "vnatre vo info");
-  }
-
-  connect(node, draw = true) {
-    if(this.floorNum !== node.floorNum) return;
-    super.connect(node)
   }
 }
Index: imaps-frontend/src/scripts/shapes/MapShape.js
===================================================================
--- imaps-frontend/src/scripts/shapes/MapShape.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/scripts/shapes/MapShape.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,123 @@
+import Konva from "konva";
+
+export default class MapShape extends Konva.Shape {
+    constructor(config, layer, blockSize, snap) {
+        if (new.target === MapShape) {
+            throw new Error("Cannot instantiate abstract class BaseShape directly.");
+        }
+        super(config);
+        this.layer = layer;
+        this.blockSize = blockSize;
+        this._type = "";
+        this.snappable = snap;
+        this._info = {};
+        this.modalEventName = "";
+        this.infoText = null;
+
+        this.shadowForStrokeEnabled(false);
+        this.on("mouseover", () => (document.body.style.cursor = "pointer"));
+        this.on("mouseout", () => (document.body.style.cursor = "default"));
+        // this.on("dblclick", (e) => {
+        //   this.moveToTop();
+        //   this.getLayer()
+        //     .find("Transformer")
+        //     .forEach((t) => t.moveToTop());
+        // });
+
+        if (snap) {
+            this.on("dragend", this.snapToGrid.bind(this));
+            this.on('dblclick', this.snapToGrid.bind(this))
+        }
+
+        this.on("transform", () => {
+            const scaleX = this.scaleX();
+            const scaleY = this.scaleY();
+            this.strokeWidth(1 / Math.max(scaleX, scaleY));
+        });
+
+        this.on('dragend', () => {
+            if (this.infoText) {
+                this.updateTextPosition();
+            }
+        });
+
+    }
+
+    loadInfo(attrs) {
+        console.log("Abstract function");
+    }
+
+
+    initText() {
+        this.textOffsetX = 0;
+        this.textOffsetY = -30;
+        this.infoText = new Konva.Text({
+            x: this.x() + this.textOffsetX,
+            y: this.y() + this.textOffsetY,
+            text: this._info.name,
+            fontSize: 12,
+            fontFamily: 'Verdana',
+            fill: 'white',
+        });
+    }
+
+    updateTextPosition() {
+        if (this.infoText) {
+            this.infoText.x(this.x() + this.textOffsetX);
+            this.infoText.y(this.y() + this.textOffsetY);
+        }
+    }
+
+    displayName(layer) {
+        if (this.infoText) {
+            this.infoText.text(this._info.name);
+            layer.add(this.infoText);
+        }
+    }
+
+    _sceneFunc(context) {
+        let width = this.width();
+        let height = this.height();
+        context.beginPath();
+        context.rect(0, 0, width, height)
+        context.closePath();
+        context.fillStrokeShape(this);
+    }
+
+    clearText() {
+        if (this.infoText !== null) {
+            this.infoText.remove()
+            console.log("cleared text")
+        }
+
+    }
+
+    snapToGrid() {
+        this.position({
+            x: Math.round(this.x() / this.blockSize) * this.blockSize,
+            y: Math.round(this.y() / this.blockSize) * this.blockSize,
+        });
+    }
+
+    saveShapeDetails() {
+        console.log("This shape does not contain information");
+    }
+
+
+    get info() {
+        return this._info;
+    }
+
+    set info(formData) {
+        this._info = formData;
+    }
+
+    get type() {
+        return this._type;
+    }
+
+    set type(type) {
+        this._type = type
+    }
+
+}
Index: imaps-frontend/src/scripts/shapes/Room.js
===================================================================
--- imaps-frontend/src/scripts/shapes/Room.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/shapes/Room.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,36 +1,27 @@
 import Konva from "konva";
-import MapShape from "../base/MapShape.js";
+import MapShape from "./MapShape";
 import { _registerNode } from "konva/lib/Global";
 export default class Room extends MapShape {
-  constructor(attrs,id){
-
-      if(!attrs.fromLoad){
-          attrs.width *= 12;
-          attrs.height *= 8;
-      }
-
-      console.log(attrs.position,"hehe")
+  constructor(mousePos, blockSize, layer, rotation, snap, id, scaleX = 1, scaleY = 1){
     super(
       {
-        x: attrs.position.x,
-        y: attrs.position.y,
-        width: attrs.width * attrs.scaleX,
-        height: attrs.height * attrs.scaleY,
-        fill: "rgb(86,168,253)",
+        x: mousePos.x,
+        y: mousePos.y,
+        width: blockSize * 8 * scaleX,
+        height: blockSize * 4 * scaleY,
+        fill: "#DDE0F8",
         stroke: "grey",
         strokeWidth: 1,
         name: "mapObj",
-        rotation: attrs.rotation,
+        rotation: rotation,
         draggable: true,
       },
-        attrs.layer,
-        attrs.blockSize,
-        attrs.snap
+      layer,
+      blockSize,
+      snap
     );
 
-      this.floorNum = attrs.floorNum;
-
     this._info = {
-      name: `Room${id} [${this.floorNum}F]`,
+      name: `Room ${id}`,
       type: "",
       description: "",
@@ -38,5 +29,5 @@
 
     this.type = "Room";
-    this.eventName = "openRoomModalEvent";
+    this.modalEventName = "openRoomModalEvent";
     this.id = id;
 
@@ -48,5 +39,4 @@
     this.info.type = attrs.room_type;
     this.info.description = attrs.description;
-    this.floorNum = attrs.floor_num;
   }
 
@@ -55,5 +45,4 @@
     this.setAttr("room_type", this.info.type);
     this.setAttr("description", this.info.description);
-    this.setAttr("floor_num",this.floorNum);
   }
 }
Index: imaps-frontend/src/scripts/shapes/Stairs.js
===================================================================
--- imaps-frontend/src/scripts/shapes/Stairs.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/shapes/Stairs.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,78 +1,4 @@
 import Konva from "konva";
-import MapNode from "../base/MapNode.js";
-import {_registerNode} from "konva/lib/Global.js";
-import Room from "./Room.js";
-export default class Stairs extends MapNode{
-    constructor(attrs,id) {
+import { MapShape } from "./MapShape";
 
-        if(!attrs.fromLoad){
-            attrs.width *= 4;
-        }
-
-        super({
-                x: attrs.position.x,
-                y: attrs.position.y,
-                width: attrs.width * attrs.scaleX,
-                height: attrs.height * attrs.scaleY,
-                fill: "rgb(225,213,124)",
-                stroke: "rgb(16,15,15)",
-                strokeWidth: 1,
-                name: "mapObj",
-                rotation: attrs.rotation,
-                draggable: true
-            },
-            attrs.layer,
-            attrs.blockSize,
-            attrs.snap
-        );
-
-        this.floorNum = attrs.floorNum;
-
-        this.type = "Stairs"
-        this._info = {
-            name: `Stairs${id} [${this.floorNum}F]`,
-            description: "",
-            selectedPins: []
-        };
-
-        this.id = id;
-        this.eventName = "openStairsModalEvent";
-        this.initText();
-    }
-
-
-    _sceneFunc(context, shape) {
-        const { width, height} = this.attrs;
-
-        let steps = 5;
-        context.beginPath()
-        for(let i = 0; i < steps; i++){
-            context.rect((-this.blockSize) * i,(this.blockSize * 0.6) * i,width * 0.86,height/2)
-            context.fillStrokeShape(shape);
-        }
-        context.closePath()
-    }
-
-    loadInfo(attrs) {
-        this.info.name = attrs.obj_name;
-        this.info.description = attrs.description;
-        this.info.selectedPins = attrs.connected_pins;
-        this.floorNum = attrs.floor_num;
-    }
-
-    saveShapeDetails() {
-        this.setAttr("connected_pins", this.info.selectedPins);
-        this.setAttr("obj_name", this.info.name);
-        this.setAttr("description", this.info.description);
-        this.setAttr("floor_num",this.floorNum)
-    }
-    connect(node,draw = true) {
-        let canDraw = this.floorNum === node.floorNum;
-        super.connect(node,canDraw);
-    }
-
-}
-
-Stairs.prototype.className = "Stairs";
-_registerNode(Stairs);
 //TODO
Index: imaps-frontend/src/scripts/shapes/Wall.js
===================================================================
--- imaps-frontend/src/scripts/shapes/Wall.js	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/scripts/shapes/Wall.js	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,43 +1,29 @@
 import Konva from "konva";
-import MapShape from "../base/MapShape.js";
+import MapShape from "./MapShape";
 import { _registerNode } from 'konva/lib/Global';
 export default class Wall extends MapShape {
-    constructor(attrs){
-        if(!attrs.fromLoad){
-            attrs.height *= 8;
-        }
-
-
+    constructor(mousePos, blockSize, layer, rotation,snap, draggable = true,scaleX = 1, scaleY = 1){
       super(
         {
-          x: attrs.position.x,
-          y: attrs.position.y,
-          width: attrs.width * attrs.scaleX,
-          height: attrs.height * attrs.scaleY,
-          fill: "#d3d3d3",
+          x: mousePos.x,
+          y: mousePos.y,
+          width: blockSize * scaleX,
+          height: blockSize * 8 * scaleY,
+          fill: "#DDE0F8",
           stroke: "grey",
           strokeWidth: 1,
           name: "mapObj",
-          draggable: true,
-          rotation: attrs.rotation,
+          draggable: draggable,
+          rotation: rotation,
           zIndex: 0,
         },
-        attrs.layer,
-        attrs.blockSize,
-        attrs.snap,
+        layer,
+        blockSize,
+        snap,
       );
+  
       this.type = "Wall";
-
-        this.floorNum = attrs.floorNum;
     }
-
-    loadInfo(attrs) {
-        this.floorNum = attrs.floor_num;
-    }
-
-    saveShapeDetails() {
-        this.setAttr("floor_num",this.floorNum)
-    }
-}
+  }
 
   Wall.prototype.className = 'Wall'
